
#
#   HTML-Kit Plugins API 1.0.50
#   Copyright (C) 1998-2002, Chami.com
#   All Rights Reserved.
# 
# 
#   HKPAPI Reference:
#     http://www.chami.com/html-kit/devref/
# 
#   HTML-Kit Developer Tools:
#     http://www.chami.com/html-kit/devtools/
# 
#   Sample Plugins:
#     http://www.chami.com/html-kit/plugins/#devfiles
# 


require 'win32ole'


class HKPCore

  
  
  # Constants 
  
  def hkp_c_HKPAPI_VER()                       '1.0.50' end
  def hkp_c_URL_HOME()                         'http://www.chami.com/html-kit/' end
  def hkp_c_URL_DOWNLOAD()                     'http://www.chami.com/html-kit/plugins/' end
  
  def hkp_c_str_TRUE()                         '1' end
  def hkp_c_str_FALSE()                        '0' end
  def hkp_c_TRUE()                             1 end
  def hkp_c_FALSE()                            0 end
  
  def hkp_c_OLEObj_HKPCore()                   'htmlkit.HTMLKitPluginsCore' end
  
  def hkp_c_CaseDefault()                      0 end
  def hkp_c_CaseLower()                        1 end
  def hkp_c_CaseUpper()                        2 end
  
  def hkp_c_QuoteDefault()                     0 end
  def hkp_c_QuoteSingle()                      1 end
  def hkp_c_QuoteDouble()                      2 end
  
  def hkp_c_ColorDefault()                     0 end
  def hkp_c_ColorHex6()                        1 end
  def hkp_c_ColorName()                        2 end
  def hkp_c_ColorHex3()                        3 end
  def hkp_c_ColorRGB()                         4 end
  def hkp_c_ColorRGBPercent()                  5 end
  
  def hkp_c_ETETDefault()                      0 end
  def hkp_c_ETETInclSpc()                      1 end
  def hkp_c_ETETExclSpc()                      2 end
  
  def hkp_c_EqualDefault()                     0 end
  def hkp_c_EqualSpaceNone()                   1 end
  def hkp_c_EqualSpaceLeft()                   2 end
  def hkp_c_EqualSpaceRight()                  3 end
  def hkp_c_EqualSpaceBoth()                   4 end
  
  def hkp_c_SpaceOptDefault()                  0 end
  def hkp_c_SpaceOptInclude()                  1 end
  def hkp_c_SpaceOptExclude()                  2 end
  
  def hkp_c_NewLineOptDefault()                0 end
  def hkp_c_NewLineOptInclude()                1 end
  def hkp_c_NewLineOptExclude()                2 end
  
  def hkp_c_FormatTag_Token()                  '^' end
  def hkp_c_FormatTag_NormalText()             'N' end
  def hkp_c_FormatTag_Tag()                    'T' end
  def hkp_c_FormatTag_Attr()                   'A' end
  def hkp_c_FormatTag_Value()                  'V' end
  def hkp_c_FormatTag_Entity()                 'E' end
  def hkp_c_FormatTag_Event()                  'S' end
  def hkp_c_FormatTag_Property()               'P' end
  def hkp_c_FormatTag_Color()                  'C' end
  def hkp_c_FormatTag_ColorExt()               'c' end
  def hkp_c_FormatTag_QuoteReq()               'Q' end
  def hkp_c_FormatTag_QuoteOpt()               'q' end
  def hkp_c_FormatTag_ETETReq()                'Z' end
  def hkp_c_FormatTag_ETETOpt()                'z' end
  def hkp_c_FormatTag_Equal()                  'U' end
  def hkp_c_FormatTag_SpaceOpt()               'o' end
  def hkp_c_FormatTag_NewLineOpt()             'l' end
  
  def hkp_c_str_DefaultQuote()                 '"' end
  def hkp_c_chr_DefaultQuote()                 '"' end
  
  def hkp_c_str_ETETInclSpc()                  ' /' end
  def hkp_c_str_ETETExclSpc()                  '/' end
  def hkp_c_str_DefaultETET()                  ' /' end
  
  def hkp_c_str_DefaultEqual()                 '=' end
  def hkp_c_chr_DefaultEqual()                 '=' end
  
  def hkp_c_str_DefaultSpaceOpt()              ' ' end
  def hkp_c_chr_DefaultSpaceOpt()              ' ' end
  
  def hkp_c_str_DefaultNewLineOpt()            '\n' end
  def hkp_c_chr_DefaultNewLineOpt()            '\n' end
  
  
  # Section names 
  
  def hkp_c_Section_Objects()                  'Objects' end
  def hkp_c_Section_Validators()               'Validators' end
  def hkp_c_Section_Converters()               'Converters' end
  def hkp_c_Section_Tables()                   'Tables' end
  def hkp_c_Section_Forms()                    'Forms' end
  def hkp_c_Section_Formats()                  'Formats' end
  def hkp_c_Section_Documents()                'Document' end
  def hkp_c_Section_Style()                    'Style' end
  def hkp_c_Section_Tools()                    'Tools' end
  def hkp_c_Section_Text()                     'Text' end
  def hkp_c_Section_Common()                   'Common' end
  def hkp_c_Section_Invisibles()               'Invisibles' end
  def hkp_c_Section_Online()                   'Online' end
  def hkp_c_Section_BatchActions()             'Batch Actions' end
  
  
  # Parameters 
  
  def hkp_NAME()                               'NAME' end
  def hkp_VERSION()                            'VERSION' end
  def hkp_SECTION()                            'SECTION' end
  
  
  def hkp_DESCRIPTION()                        'DESCRIPTION' end
  def hkp_HINT()                               'HINT' end
  def hkp_ICON_LARGE()                         'ICON_LARGE' end
  def hkp_ICON_SMALL()                         'ICON_SMALL' end
  def hkp_COPYRIGHT_SHORT()                    'COPYRIGHT_SHORT' end
  def hkp_COPYRIGHT_LONG()                     'COPYRIGHT_LONG' end
  def hkp_LICENSE_TYPE()                       'LICENSE_TYPE' end
  def hkp_LICENSE_DESCRIPTION()                'LICENSE_DESCRIPTION' end
  def hkp_LICENSE_URL()                        'LICENSE_URL' end
  def hkp_REGISTRATION_TYPE()                  'REGISTRATION_TYPE' end
  def hkp_REGISTRATION_DESCRIPTION()           'REGISTRATION_DESCRIPTION' end
  def hkp_REGISTRATION_FEE()                   'REGISTRATION_FEE' end
  def hkp_REGISTRATION_URL()                   'REGISTRATION_URL' end
  def hkp_URL_HELP()                           'URL_HELP' end
  
  
  def hkp_UPID()                               'UPID' end
  def hkp_HELP_FILE()                          'HELP_FILE' end
  def hkp_HELP_CONTEXT()                       'HELP_CONTEXT' end
  def hkp_HOTKEY()                             'HOTKEY' end
  def hkp_ICON_CAPTION()                       'ICON_CAPTION' end
  def hkp_ENABLED()                            'ENABLED' end
  def hkp_MENU_CAPTION()                       'MENU_CAPTION' end
  def hkp_AUTHOR()                             'AUTHOR' end
  def hkp_PHONE()                              'PHONE' end
  def hkp_COMPANY()                            'COMPANY' end
  def hkp_MAILING_ADDRESS()                    'MAILING_ADDRESS' end
  def hkp_EMAIL()                              'EMAIL' end
  def hkp_URL_HOME()                           'URL_HOME' end
  def hkp_URL_DOWNLOAD()                       'URL_DOWNLOAD' end
  def hkp_MENU_ITEM1()                         'MENU_ITEM1' end
  def hkp_MENU_ITEM2()                         'MENU_ITEM2' end
  def hkp_MENU_ITEM3()                         'MENU_ITEM3' end
  def hkp_MENU_ITEM4()                         'MENU_ITEM4' end
  def hkp_MENU_ITEM5()                         'MENU_ITEM5' end
  def hkp_DROPDOWN_ITEM()                      'DROPDOWN_ITEM' end
  def hkp_DROPDOWN_ITEM_HINT()                 'DROPDOWN_ITEM_HINT' end
  def hkp_DROPDOWN_ITEM_ICON()                 'DROPDOWN_ITEM_ICON' end
  def hkp_DROPDOWN_ITEM_PHRASE()               'DROPDOWN_ITEM_PHRASE' end
  def hkp_ARGV1()                              'ARGV1' end
  def hkp_ARGV2()                              'ARGV2' end
  def hkp_ARGV3()                              'ARGV3' end
  def hkp_ARGV4()                              'ARGV4' end
  def hkp_ARGV5()                              'ARGV5' end
  def hkp_EVENT()                              'EVENT' end
  def hkp_COMMAND_BUILTIN()                    'COMMAND_BUILTIN' end
  def hkp_HKPCORE_PLUGIN_INVOKE_MODE_ENV()     'HKPCORE_PLUGIN_INVOKE_MODE_ENV' end
  
  def hkp_MODE_CONSOLE()                       'MODE_CONSOLE' end
  def hkp_MODE_SHOW_STATUS()                   'MODE_SHOW_STATUS' end
  def hkp_MODE_IN_TEXT_FULL()                  'MODE_IN_TEXT_FULL' end
  def hkp_MODE_IN_TEXT_SELECTED()              'MODE_IN_TEXT_SELECTED' end
  def hkp_MODE_IN_WORD_AT_CURSOR()             'MODE_IN_WORD_AT_CURSOR' end
  def hkp_MODE_IN_TAG_AT_CURSOR()              'MODE_IN_TAG_AT_CURSOR' end
  def hkp_MODE_IN_LINE_AT_CURSOR()             'MODE_IN_LINE_AT_CURSOR' end
  def hkp_MODE_IN_FILE()                       'MODE_IN_FILE' end
  def hkp_MODE_IN_FILE_EXT()                   'MODE_IN_FILE_EXT' end
  def hkp_MODE_IN_FILE_DELETE()                'MODE_IN_FILE_DELETE' end
  def hkp_MODE_MOVE_TO_CARET()                 'MODE_MOVE_TO_CARET' end
  def hkp_MODE_PREPROCESS()                    'MODE_PREPROCESS' end
  def hkp_MODE_SAVE_FIRST()                    'MODE_SAVE_FIRST' end
  def hkp_MODE_DEBUG_PLUGIN()                  'MODE_DEBUG_PLUGIN' end
  def hkp_MODE_ADD_MENU_SHORTCUTS()            'MODE_ADD_MENU_SHORTCUTS' end
  def hkp_MODE_PREPROCESS_FORMAT_TAGS()        'MODE_PREPROCESS_FORMAT_TAGS' end
  def hkp_MODE_BEGIN_GROUP()                   'MODE_BEGIN_GROUP' end
  def hkp_MODE_END_GROUP()                     'MODE_END_GROUP' end
  def hkp_MODE_APPEARANCE_ICONS()              'MODE_APPEARANCE_ICONS' end
  def hkp_MODE_EDITOR_REQUIRED()               'MODE_EDITOR_REQUIRED' end
  def hkp_MODE_FOCUS_EDITOR()                  'MODE_FOCUS_EDITOR' end
  def hkp_MODE_EGG()                           'MODE_EGG' end
  def hkp_MODE_INFO_KEYWORDS()                 'MODE_INFO_KEYWORDS' end
  
  def hkp_c_Button_Event_OnClick()             1 end
  def hkp_c_Menu_Event_OnClick()               10 end
  
  def hkp_BUTTON_VISIBLE()                     'BUTTON_VISIBLE' end
  
  def hkp_PREVIEW_EVENT_ONPREVIEW()            'PREVIEW_EVENT_ONPREVIEW' end
  def hkp_c_Preview_Event_OnPreview()          1100 end
  def hkp_PREVIEW_OUTPUT_URL()                 'PREVIEW_OUTPUT_URL' end
  def hkp_PREVIEW_OUTPUT_CONTENT()             'PREVIEW_OUTPUT_CONTENT' end
  def hkp_MODE_PREVIEW_PASS_TO_NEXT()          'MODE_PREVIEW_PASS_TO_NEXT' end
  def hkp_MODE_PREVIEW_IN_URL()                'MODE_PREVIEW_IN_URL' end
  def hkp_MODE_PREVIEW_IN_CONTENT()            'MODE_PREVIEW_IN_CONTENT' end
  def hkp_PREVIEW_IN_URL()                     'PREVIEW_IN_URL' end
  def hkp_PREVIEW_IN_CONTENT()                 'PREVIEW_IN_CONTENT' end
  
  def hkp_COMMANDPROMPT_EVENT_ONINVOKE()       'COMMANDPROMPT_EVENT_ONINVOKE' end
  def hkp_c_CommandPrompt_Event_OnInvoke()     1400 end
  def hkp_COMMANDPROMPT_HINT()                 'COMMANDPROMPT_HINT' end
  def hkp_COMMANDPROMPT_HELP()                 'COMMANDPROMPT_HELP' end
  def hkp_COMMANDPROMPT_COMMANDS()             'COMMANDPROMPT_COMMANDS' end
  def hkp_COMMANDPROMPT_OUTPUT()               'COMMANDPROMPT_OUTPUT' end
  def hkp_COMMANDPROMPT_HANDLED()              'COMMANDPROMPT_HANDLED' end
  def hkp_CAPABILITY_COMMANDPROMPT()           'CAPABILITY_COMMANDPROMPT' end
  def hkp_COMMANDPROMPT_IN_CMDLINE_FULL()      'COMMANDPROMPT_IN_CMDLINE_FULL' end
  def hkp_COMMANDPROMPT_IN_CMDLINE_COMMAND()   'COMMANDPROMPT_IN_CMDLINE_COMMAND' end
  def hkp_COMMANDPROMPT_IN_CMDLINE_PARAMS()    'COMMANDPROMPT_IN_CMDLINE_PARAMS' end
  def hkp_COMMANDPROMPT_IN_CMDLINE_PARAM()     'COMMANDPROMPT_IN_CMDLINE_PARAM' end
  
  def hkp_TEMPLATEWIZARD_CAPTION()             'TEMPLATEWIZARD_CAPTION' end
  def hkp_TEMPLATEWIZARD_HINT()                'TEMPLATEWIZARD_HINT' end
  def hkp_TEMPLATEWIZARD_EVENT_ONINVOKE()      'TEMPLATEWIZARD_EVENT_ONINVOKE' end
  def hkp_c_TemplateWizard_Event_OnInvoke()    1500 end
  def hkp_CAPABILITY_TEMPLATEWIZARD()          'CAPABILITY_TEMPLATEWIZARD' end
  
  def hkp_CAPABILITY_AUTORESIZINGMENU()        'CAPABILITY_AUTORESIZINGMENU' end
  
  def hkp_BUFFER_CAPTION()                     'BUFFER_CAPTION' end
  def hkp_BUFFER_HINT()                        'BUFFER_HINT' end
  def hkp_BUFFER_EVENT_ONINVOKE()              'BUFFER_EVENT_ONINVOKE' end
  def hkp_BUFFER_EVENT_ONSTART()               'BUFFER_EVENT_ONSTART' end
  def hkp_BUFFER_EVENT_ONEND()                 'BUFFER_EVENT_ONEND' end
  def hkp_BUFFER_EVENT_ONENTERFOLDER()         'BUFFER_EVENT_ONENTERFOLDER' end
  def hkp_BUFFER_EVENT_ONEXITFOLDER()          'BUFFER_EVENT_ONEXITFOLDER' end
  def hkp_c_Buffer_Event_OnInvoke()            1600 end
  def hkp_c_Buffer_Event_OnStart()             1610 end
  def hkp_c_Buffer_Event_OnEnd()               1611 end
  def hkp_c_Buffer_Event_OnEnterFolder()       1620 end
  def hkp_c_Buffer_Event_OnExitFolder()        1621 end
  def hkp_CAPABILITY_BUFFER()                  'CAPABILITY_BUFFER' end
  def hkp_MODE_BUFFER_IN_FILE()                'MODE_BUFFER_IN_FILE' end
  def hkp_MODE_BUFFER_IN_CONTENT()             'MODE_BUFFER_IN_CONTENT' end
  def hkp_MODE_BUFFER_VISIBLE_MAINMENU()       'MODE_BUFFER_VISIBLE_MAINMENU' end
  def hkp_MODE_BUFFER_VISIBLE_WORKSPACE()      'MODE_BUFFER_VISIBLE_WORKSPACE' end
  def hkp_MODE_BUFFER_ACCESS_READ()            'MODE_BUFFER_ACCESS_READ' end
  def hkp_MODE_BUFFER_ACCESS_WRITE()           'MODE_BUFFER_ACCESS_WRITE' end
  def hkp_MODE_BUFFER_ACCESS_CREATE()          'MODE_BUFFER_ACCESS_CREATE' end
  def hkp_MODE_BUFFER_CACHE_PLUGIN_DISABLE()   'MODE_BUFFER_CACHE_PLUGIN_DISABLE' end
  def hkp_MODE_BUFFER_INFO_PLUGIN_FULL()       'MODE_BUFFER_INFO_PLUGIN_FULL' end
  def hkp_MODE_BUFFER_INFO_USER_HIDE()         'MODE_BUFFER_INFO_USER_HIDE' end
  def hkp_MODE_BUFFER_FILTER_REGEX_EXPR()      'MODE_BUFFER_FILTER_REGEX_EXPR' end
  def hkp_MODE_BUFFER_FILTER_REGEX_OPT()       'MODE_BUFFER_FILTER_REGEX_OPT' end
  def hkp_MODE_BUFFER_FILETYPES_INCLUDED()     'MODE_BUFFER_FILETYPES_INCLUDED' end
  def hkp_MODE_BUFFER_FILETYPES_EXCLUDED()     'MODE_BUFFER_FILETYPES_EXCLUDED' end
  def hkp_BUFFER_IN_CONTENT()                  'BUFFER_IN_CONTENT' end
  def hkp_BUFFER_IN_FILE()                     'BUFFER_IN_FILE' end
  def hkp_BUFFER_IN_PATH()                     'BUFFER_IN_PATH' end
  def hkp_BUFFER_IN_DEPTH()                    'BUFFER_IN_DEPTH' end
  def hkp_BUFFER_IN_PARAM1()                   'BUFFER_IN_PARAM1' end
  def hkp_BUFFER_IN_PARAM2()                   'BUFFER_IN_PARAM2' end
  def hkp_BUFFER_IN_PARAM3()                   'BUFFER_IN_PARAM3' end
  def hkp_BUFFER_IN_PARAM4()                   'BUFFER_IN_PARAM4' end
  def hkp_BUFFER_PARAM_LABEL1()                'BUFFER_PARAM_LABEL1' end
  def hkp_BUFFER_PARAM_LABEL2()                'BUFFER_PARAM_LABEL2' end
  def hkp_BUFFER_PARAM_LABEL3()                'BUFFER_PARAM_LABEL3' end
  def hkp_BUFFER_PARAM_LABEL4()                'BUFFER_PARAM_LABEL4' end
  def hkp_BUFFER_PARAM_VALUE1()                'BUFFER_PARAM_VALUE1' end
  def hkp_BUFFER_PARAM_VALUE2()                'BUFFER_PARAM_VALUE2' end
  def hkp_BUFFER_PARAM_VALUE3()                'BUFFER_PARAM_VALUE3' end
  def hkp_BUFFER_PARAM_VALUE4()                'BUFFER_PARAM_VALUE4' end
  def hkp_BUFFER_PARAM_HINT1()                 'BUFFER_PARAM_HINT1' end
  def hkp_BUFFER_PARAM_HINT2()                 'BUFFER_PARAM_HINT2' end
  def hkp_BUFFER_PARAM_HINT3()                 'BUFFER_PARAM_HINT3' end
  def hkp_BUFFER_PARAM_HINT4()                 'BUFFER_PARAM_HINT4' end
  def hkp_MODE_SESSION_ENABLE()                'MODE_SESSION_ENABLE' end
  def hkp_BUFFER_REPORT_OUTPUT()               'BUFFER_REPORT_OUTPUT' end
  def hkp_SESSION_VAR_COUNT()                  'SESSION_VAR_COUNT' end
  def hkp_SESSION_VAR1()                       'SESSION_VAR1' end
  def hkp_SESSION_VAR2()                       'SESSION_VAR2' end
  def hkp_SESSION_VAR3()                       'SESSION_VAR3' end
  def hkp_SESSION_VAR4()                       'SESSION_VAR4' end
  def hkp_SESSION_FRIENDS()                    'SESSION_FRIENDS' end
  
  def hkp_DRAGDROP_ACCEPT_FILEMASKS()          'DRAGDROP_ACCEPT_FILEMASKS' end
  def hkp_DRAGDROP_ACCEPT_MODES()              'DRAGDROP_ACCEPT_MODES' end
  def hkp_MODE_DRAGDROP_IN_SOURCE_FILE_LOCAL()  'MODE_DRAGDROP_IN_SOURCE_FILE_LOCAL' end
  def hkp_DRAGDROP_EVENT_ONDROP()              'DRAGDROP_EVENT_ONDROP' end
  def hkp_DRAGDROP_OUTPUT()                    'DRAGDROP_OUTPUT' end
  def hkp_DRAGDROP_IN_MODE()                   'DRAGDROP_IN_MODE' end
  def hkp_DRAGDROP_IN_SOURCE_FILE_PATH_ABS()   'DRAGDROP_IN_SOURCE_FILE_PATH_ABS' end
  def hkp_DRAGDROP_IN_SOURCE_FILE_PATH_REL()   'DRAGDROP_IN_SOURCE_FILE_PATH_REL' end
  def hkp_DRAGDROP_IN_SOURCE_FILE_NAME_EXT()   'DRAGDROP_IN_SOURCE_FILE_NAME_EXT' end
  def hkp_DRAGDROP_IN_SOURCE_FILE_NAME_FULL()  'DRAGDROP_IN_SOURCE_FILE_NAME_FULL' end
  def hkp_DRAGDROP_IN_SOURCE_PATH_ABS()        'DRAGDROP_IN_SOURCE_PATH_ABS' end
  def hkp_DRAGDROP_IN_SOURCE_PATH_REL()        'DRAGDROP_IN_SOURCE_PATH_REL' end
  def hkp_DRAGDROP_IN_SOURCE_FILE_LOCAL()      'DRAGDROP_IN_SOURCE_FILE_LOCAL' end
  
  def hkp_c_DragDrop_Event_OnDrop()            1700 end
  def hkp_c_DragDrop_Mode_Workspace()          1 end
  
  def hkp_CAPABILITY_DRAGDROP()                'CAPABILITY_DRAGDROP' end
  
  def hkp_RECALL_EVENT_ONINVOKE()              'RECALL_EVENT_ONINVOKE' end
  def hkp_RECALL_IN_DATA1()                    'RECALL_IN_DATA1' end
  def hkp_RECALL_IN_DATA2()                    'RECALL_IN_DATA2' end
  def hkp_c_Recall_Event_OnInvoke()            1800 end
  def hkp_CAPABILITY_RECALL()                  'CAPABILITY_RECALL' end
  
  def hkp_MODE_UNINSTALL()                     'MODE_UNINSTALL' end
  def hkp_UNINSTALL_FILE_ABS()                 'UNINSTALL_FILE_ABS' end
  def hkp_UNINSTALL_FILE_REL()                 'UNINSTALL_FILE_REL' end
  def hkp_UNINSTALL_FILE_REL_PLUGINS()         'UNINSTALL_FILE_REL_PLUGINS' end
  def hkp_UNINSTALL_FILE_REL_PLUGINS_CONFIG()  'UNINSTALL_FILE_REL_PLUGINS_CONFIG' end
  def hkp_UNINSTALL_FILE_REL_PLUGINS_BIN()     'UNINSTALL_FILE_REL_PLUGINS_BIN' end
  def hkp_UNINSTALL_FILE_REL_PLUGINS_LIB()     'UNINSTALL_FILE_REL_PLUGINS_LIB' end
  def hkp_UNINSTALL_DIR_ABS()                  'UNINSTALL_DIR_ABS' end
  def hkp_UNINSTALL_DIR_REL_PLUGINS_CONFIG()   'UNINSTALL_DIR_REL_PLUGINS_CONFIG' end
  def hkp_UNINSTALL_REG_ABS()                  'UNINSTALL_REG_ABS' end
  def hkp_UNINSTALL_REG_REL()                  'UNINSTALL_REG_REL' end
  def hkp_UNINSTALL_EVENT_ONINVOKE()           'UNINSTALL_EVENT_ONINVOKE' end
  def hkp_c_Uninstall_Event_OnInvoke()         2000 end
  def hkp_CAPABILITY_UNINSTALL()               'CAPABILITY_UNINSTALL' end
  
  def hkp_CAPABILITY_TEXTTOSPEECH()            'CAPABILITY_TEXTTOSPEECH' end
  def hkp_CAPABILITY_SPEECHRECOGNITION()       'CAPABILITY_SPEECHRECOGNITION' end
  
  def hkp_CONTEXTMENU_EDITOR_EVENT_ONINIT()    'CONTEXTMENU_EDITOR_EVENT_ONINIT' end
  def hkp_CONTEXTMENU_EDITOR_EVENT_ONOPEN()    'CONTEXTMENU_EDITOR_EVENT_ONOPEN' end
  def hkp_CONTEXTMENU_EDITOR_EVENT_ONCLOSE()   'CONTEXTMENU_EDITOR_EVENT_ONCLOSE' end
  def hkp_CONTEXTMENU_EDITOR_EVENT_ONCLICK()   'CONTEXTMENU_EDITOR_EVENT_ONCLICK' end
  def hkp_c_ContextMenu_Editor_Event_OnInit()   1200 end
  def hkp_c_ContextMenu_Editor_Event_OnOpen()   1201 end
  def hkp_c_ContextMenu_Editor_Event_OnClose()  1202 end
  def hkp_c_ContextMenu_Editor_Event_OnClick()  1203 end
  def hkp_CONTEXTMENU_EDITOR_VISIBLE()         'CONTEXTMENU_EDITOR_VISIBLE' end
  def hkp_CONTEXTMENU_EDITOR_ENABLED()         'CONTEXTMENU_EDITOR_ENABLED' end
  def hkp_CONTEXTMENU_EDITOR_SECTION()         'CONTEXTMENU_EDITOR_SECTION' end
  def hkp_CONTEXTMENU_EDITOR_HINT()            'CONTEXTMENU_EDITOR_HINT' end
  def hkp_CONTEXTMENU_EDITOR_HINT_INIT()       'CONTEXTMENU_EDITOR_HINT_INIT' end
  def hkp_CONTEXTMENU_EDITOR_HINT_QUIT()       'CONTEXTMENU_EDITOR_HINT_QUIT' end
  def hkp_CONTEXTMENU_EDITOR_ICONINDEX()       'CONTEXTMENU_EDITOR_ICONINDEX' end
  def hkp_CONTEXTMENU_EDITOR_ITEM()            'CONTEXTMENU_EDITOR_ITEM' end
  def hkp_CONTEXTMENU_EDITOR_ITEM_HINT()       'CONTEXTMENU_EDITOR_ITEM_HINT' end
  def hkp_CONTEXTMENU_EDITOR_ITEM_DATA()       'CONTEXTMENU_EDITOR_ITEM_DATA' end
  def hkp_CONTEXTMENU_EDITOR_ITEM_ICONINDEX()  'CONTEXTMENU_EDITOR_ITEM_ICONINDEX' end
  def hkp_CONTEXTMENU_EDITOR_ITEM_ENABLED()    'CONTEXTMENU_EDITOR_ITEM_ENABLED' end
  def hkp_MODE_CONTEXTMENU_EDITOR_PRELOAD()    'MODE_CONTEXTMENU_EDITOR_PRELOAD' end
  
  def hkp_CAPABILITY_CONTEXTMENU_EDITOR()      'CAPABILITY_CONTEXTMENU_EDITOR' end
  def hkp_CAPABILITY_PREVIEW_DEFAULT()         'CAPABILITY_PREVIEW_DEFAULT' end
  
  def hkp_ICON_INDEX()                         'ICON_INDEX' end
  def hkp_ICON_SHARED_INDEX()                  'ICON_SHARED_INDEX' end
  
  def hkp_LABEL_VISIBLE()                      'LABEL_VISIBLE' end
  def hkp_LABEL_WIDTH()                        'LABEL_WIDTH' end
  def hkp_LABEL_WIDTH_CHAR()                   'LABEL_WIDTH_CHAR' end
  def hkp_LABEL_HINT()                         'LABEL_HINT' end
  def hkp_LABEL_TEXT()                         'LABEL_TEXT' end
  def hkp_LABEL_ALIGNMENT()                    'LABEL_ALIGNMENT' end
  def hkp_LABEL_STYLE()                        'LABEL_STYLE' end
  def hkp_LABEL_DIRTY()                        'LABEL_DIRTY' end
  def hkp_LABEL_HANDLE()                       'LABEL_HANDLE' end
  def hkp_LABEL_EVENT_ONCLICK()                'LABEL_EVENT_ONCLICK' end
  def hkp_LABEL_EVENT_ONDBLCLICK()             'LABEL_EVENT_ONDBLCLICK' end
  def hkp_LABEL_EVENT_ONMOUSEDOWN()            'LABEL_EVENT_ONMOUSEDOWN' end
  
  def hkp_c_Label_Event_OnClick()              50 end
  def hkp_c_Label_Event_OnDblClick()           51 end
  def hkp_c_Label_Event_OnMouseDown()          52 end
  def hkp_c_Label_Alignment_Left()             95 end
  def hkp_c_Label_Alignment_Center()           96 end
  def hkp_c_Label_Alignment_Right()            97 end
  def hkp_c_Label_GetData()                    98 end
  def hkp_c_Label_SetData()                    99 end
  
  def hkp_COMBOBOX_VISIBLE()                   'COMBOBOX_VISIBLE' end
  def hkp_COMBOBOX_WIDTH()                     'COMBOBOX_WIDTH' end
  def hkp_COMBOBOX_WIDTH_CHAR()                'COMBOBOX_WIDTH_CHAR' end
  def hkp_COMBOBOX_DROPDOWN_COUNT()            'COMBOBOX_DROPDOWN_COUNT' end
  def hkp_COMBOBOX_HINT()                      'COMBOBOX_HINT' end
  def hkp_COMBOBOX_STYLE()                     'COMBOBOX_STYLE' end
  def hkp_COMBOBOX_SORTED()                    'COMBOBOX_SORTED' end
  def hkp_COMBOBOX_TEXT()                      'COMBOBOX_TEXT' end
  def hkp_COMBOBOX_CHAR_MAX()                  'COMBOBOX_CHAR_MAX' end
  def hkp_COMBOBOX_DIRTY()                     'COMBOBOX_DIRTY' end
  def hkp_COMBOBOX_HANDLE()                    'COMBOBOX_HANDLE' end
  def hkp_COMBOBOX_ITEMS_GET()                 'COMBOBOX_ITEMS_GET' end
  def hkp_COMBOBOX_ITEMS_COUNT()               'COMBOBOX_ITEMS_COUNT' end
  def hkp_COMBOBOX_ITEMS_CURR_INDEX()          'COMBOBOX_ITEMS_CURR_INDEX' end
  def hkp_COMBOBOX_ITEMS_CURR_TEXT()           'COMBOBOX_ITEMS_CURR_TEXT' end
  def hkp_COMBOBOX_ITEMS_CURR_DATA()           'COMBOBOX_ITEMS_CURR_DATA' end
  def hkp_COMBOBOX_ITEMS_DELETE_ALL()          'COMBOBOX_ITEMS_DELETE_ALL' end
  def hkp_COMBOBOX_ITEMS_INSERT_TOP()          'COMBOBOX_ITEMS_INSERT_TOP' end
  def hkp_COMBOBOX_ITEMS_IGNORE_DUPLICATES()   'COMBOBOX_ITEMS_IGNORE_DUPLICATES' end
  def hkp_COMBOBOX_ITEM()                      'COMBOBOX_ITEM' end
  def hkp_COMBOBOX_ITEM_DATA()                 'COMBOBOX_ITEM_DATA' end
  def hkp_COMBOBOX_EVENT_ONCHANGE()            'COMBOBOX_EVENT_ONCHANGE' end
  def hkp_COMBOBOX_EVENT_ONDROPDOWN()          'COMBOBOX_EVENT_ONDROPDOWN' end
  def hkp_COMBOBOX_EVENT_ONCLICK()             'COMBOBOX_EVENT_ONCLICK' end
  def hkp_COMBOBOX_EVENT_ONKEYPRESS()          'COMBOBOX_EVENT_ONKEYPRESS' end
  def hkp_COMBOBOX_EVENT_ONMOUSEDOWN()         'COMBOBOX_EVENT_ONMOUSEDOWN' end
  def hkp_COMBOBOX_KEYPRESS_FILTER()           'COMBOBOX_KEYPRESS_FILTER' end
  
  def hkp_c_ComboBox_Event_OnChange()          100 end
  def hkp_c_ComboBox_Event_OnDropDown()        101 end
  def hkp_c_ComboBox_Event_OnClick()           102 end
  def hkp_c_ComboBox_Event_OnKeyPress()        103 end
  def hkp_c_ComboBox_Event_OnMouseDown()       104 end
  def hkp_c_ComboBox_GetData()                 145 end
  def hkp_c_ComboBox_SetData()                 146 end
  def hkp_c_ComboBox_Style_DropDown()          147 end
  def hkp_c_ComboBox_Style_DropDownList()      148 end
  def hkp_c_ComboBox_Style_Simple()            149 end
  
  def hkp_EDITFIELD_VISIBLE()                  'EDITFIELD_VISIBLE' end
  def hkp_EDITFIELD_WIDTH()                    'EDITFIELD_WIDTH' end
  def hkp_EDITFIELD_WIDTH_CHAR()               'EDITFIELD_WIDTH_CHAR' end
  def hkp_EDITFIELD_HINT()                     'EDITFIELD_HINT' end
  def hkp_EDITFIELD_TEXT()                     'EDITFIELD_TEXT' end
  def hkp_EDITFIELD_CHAR_MAX()                 'EDITFIELD_CHAR_MAX' end
  def hkp_EDITFIELD_DIRTY()                    'EDITFIELD_DIRTY' end
  def hkp_EDITFIELD_HANDLE()                   'EDITFIELD_HANDLE' end
  def hkp_EDITFIELD_EVENT_ONCHANGE()           'EDITFIELD_EVENT_ONCHANGE' end
  def hkp_EDITFIELD_EVENT_ONKEYPRESS()         'EDITFIELD_EVENT_ONKEYPRESS' end
  def hkp_EDITFIELD_EVENT_ONMOUSEDOWN()        'EDITFIELD_EVENT_ONMOUSEDOWN' end
  def hkp_EDITFIELD_KEYPRESS_FILTER()          'EDITFIELD_KEYPRESS_FILTER' end
  
  def hkp_c_EditField_Event_OnChange()         150 end
  def hkp_c_EditField_Event_OnKeyPress()       151 end
  def hkp_c_EditField_Event_OnMouseDown()      152 end
  def hkp_c_EditField_GetData()                198 end
  def hkp_c_EditField_SetData()                199 end
  
  def hkp_c_MODE_ICON_RES()                    0 end
  def hkp_c_MODE_ICON_DATA()                   1 end
  def hkp_c_MODE_ICON_FILE()                   2 end
  def hkp_c_MODE_ICON_BUILTIN()                3 end
  def hkp_c_MODE_ICON_DRAW()                   4 end
  def hkp_MODE_ICON()                          'MODE_ICON' end
  
  def hkp_c_MODE_OUTPUT_DEFAULT()              0 end
  def hkp_c_MODE_OUTPUT_CURRENTPOS()           1 end
  def hkp_c_MODE_OUTPUT_SELECTION()            2 end
  def hkp_c_MODE_OUTPUT_POPUP()                3 end
  def hkp_c_MODE_OUTPUT_CURRENTWORD()          4 end
  def hkp_c_MODE_OUTPUT_CURRENTTAG()           5 end
  def hkp_c_MODE_OUTPUT_EDITOR()               6 end
  def hkp_c_MODE_OUTPUT_EDITOR_NEW()           7 end
  def hkp_c_MODE_OUTPUT_CURRENTLINE()          8 end
  def hkp_MODE_OUTPUT()                        'MODE_OUTPUT' end
  
  def hkp_c_MODE_PLUGIN_CACHE_NONE()           0 end
  def hkp_c_MODE_PLUGIN_CACHE_ALL()            1 end
  def hkp_MODE_PLUGIN_CACHE()                  'MODE_PLUGIN_CACHE' end
  
  def hkp_PLUGIN_NAME()                        'P_NAME' end
  def hkp_PLUGIN_ID()                          'P_ID' end
  def hkp_PLUGIN_TAG()                         'P_TAG' end
  def hkp_PLUGIN_FILE()                        'PLUGIN_FILE' end
  def hkp_FILE_DISP_NAME()                     'FILE_DISP_NAME' end
  def hkp_FILE_DISP_NAME_SHORT()               'FILE_DISP_NAME_SHORT' end
  def hkp_FILE_NAME()                          'FILE_NAME' end
  def hkp_FILE_NAME_SHORT()                    'FILE_NAME_SHORT' end
  def hkp_FILE_MODIFIED()                      'FILE_MODIFIED' end
  def hkp_INPUT()                              'INPUT' end
  def hkp_INPUT_SELECTED()                     'INPUT_SELECTION' end
  def hkp_INPUT_WORD_AT_CURSOR()               'INPUT_WORD_AT_CURSOR' end
  def hkp_INPUT_TAG_AT_CURSOR()                'INPUT_TAG_AT_CURSOR' end
  def hkp_INPUT_LINE_AT_CURSOR()               'INPUT_LINE_AT_CURSOR' end
  def hkp_INPUT_FILE()                         'INPUT_FILE' end
  def hkp_OUTPUT()                             'OUTPUT' end
  
  def hkp_APPEARANCE_NAME()                    'APPEARANCE_NAME' end
  
  def hkp_NAME_LONG()                          'NAME_LONG' end
  def hkp_VER_MAJOR()                          'VER_MAJOR' end
  def hkp_VER_MINOR()                          'VER_MINOR' end
  def hkp_VER_RELEASE()                        'VER_RELEASE' end
  def hkp_VER_BUILD()                          'VER_BUILD' end
  def hkp_VER_TIMESTAMP()                      'VER_TIMESTAMP' end
  def hkp_VER_TYPE()                           'VER_TYPE' end
  def hkp_VER_RELEASE_ID()                     'VER_RELEASE_ID' end
  def hkp_VER()                                'VER' end
  def hkp_HKPAPI_VER()                         'HKPAPI_VER' end
  
  def hkp_INCOMPATIBLE()                       'INCOMPATIBLE' end
  
  def hkp_OWNER_WINDOW_HANDLE()                'OWNER_WINDOW_HANDLE' end
  def hkp_EDITOR_WINDOW_HANDLE()               'EDITOR_WINDOW_HANDLE' end
  def hkp_PROGRAM_HANDLE()                     'PROGRAM_HANDLE' end
  def hkp_EDITOR_AVAILABLE()                   'EDITOR_AVAILABLE' end
  
  def hkp_PREF_SHORT_MENUS()                   'PREF_SHORT_MENUS' end
  def hkp_PREF_MENU_HEIGHT()                   'PREF_MENU_HEIGHT' end
  
  def hkp_PREF_CASE_TAG()                      'PREF_CASE_TAG' end
  def hkp_PREF_CASE_ATTR()                     'PREF_CASE_ATTR' end
  def hkp_PREF_CASE_VALUE()                    'PREF_CASE_VALUE' end
  def hkp_PREF_CASE_ENTITY()                   'PREF_CASE_ENTITY' end
  def hkp_PREF_CASE_EVENT()                    'PREF_CASE_EVENT' end
  def hkp_PREF_CASE_PROPERTY()                 'PREF_CASE_PROPERTY' end
  def hkp_PREF_FORMAT_COLOR()                  'PREF_FORMAT_COLOR' end
  def hkp_PREF_FORMAT_QUOTE()                  'PREF_FORMAT_QUOTE' end
  def hkp_PREF_FORMAT_QUOTE_SKIP_OPTIONAL()    'PREF_FORMAT_QUOTE_SKIP_OPTIONAL' end
  def hkp_PREF_FORMAT_ETET()                   'PREF_FORMAT_ETET' end
  def hkp_PREF_FORMAT_ETET_SKIP_OPTIONAL()     'PREF_FORMAT_ETET_SKIP_OPTIONAL' end
  def hkp_PREF_FORMAT_EQUAL()                  'PREF_FORMAT_EQUAL' end
  def hkp_PREF_FORMAT_SPACE()                  'PREF_FORMAT_SPACE' end
  def hkp_PREF_FORMAT_NEWLINE()                'PREF_FORMAT_NEWLINE' end
  def hkp_PREF_FORMAT_ALT()                    'PREF_FORMAT_ALT' end
  
  def hkp_PREF_AUTHOR_NAME()                   'PREF_AUTHOR_NAME' end
  def hkp_PREF_AUTHOR_COMPANY()                'PREF_AUTHOR_COMPANY' end
  def hkp_PREF_AUTHOR_WEBSITE()                'PREF_AUTHOR_WEBSITE' end
  def hkp_PREF_AUTHOR_EMAIL()                  'PREF_AUTHOR_EMAIL' end
  def hkp_PREF_AUTHOR_COMMENTS()               'PREF_AUTHOR_COMMENTS' end
  
  def hkp_PREF_DATETIME_FORMAT()               'PREF_DATETIME_FORMAT' end
  
  def hkp_FILE_TYPE_FILTER_DOCS()              'FILE_TYPE_FILTER_DOCS' end
  def hkp_FILE_TYPE_FILTER_IMAGES()            'FILE_TYPE_FILTER_IMAGES' end
  def hkp_FILE_TYPE_FILTER_DEFAULT()           'FILE_TYPE_FILTER_DEFAULT' end
  
  def hkp_PATH_ROOT()                          'PATH_ROOT' end
  def hkp_PATH_PLUGINS()                       'PATH_PLUGINS' end
  def hkp_PATH_LAST_OPEN()                     'PATH_LAST_OPEN' end
  def hkp_PATH_LAST_SAVE()                     'PATH_LAST_SAVE' end
  def hkp_PATH_SNIPPETS_DEFAULT()              'PATH_SNIPPETS_DEFAULT' end
  def hkp_PATH_TEMPLATES_DEFAULT()             'PATH_TEMPLATES_DEFAULT' end
  def hkp_PATH_SNIPPETS_USER()                 'PATH_SNIPPETS_USER' end
  def hkp_PATH_TEMPLATES_USER()                'PATH_TEMPLATES_USER' end
  def hkp_PATH_PLUGINS_CONFIG()                'PATH_PLUGINS_CONFIG' end
  def hkp_PATH_BACKUP()                        'PATH_BACKUP' end
  def hkp_PATH_CACHE()                         'PATH_CACHE' end
  def hkp_PATH_DATA()                          'PATH_DATA' end
  def hkp_PATH_DATA_DEFAULT()                  'PATH_DATA_DEFAULT' end
  def hkp_PATH_HELP()                          'PATH_HELP' end
  def hkp_PATH_HELP_KEYWORDS()                 'PATH_HELP_KEYWORDS' end
  def hkp_PATH_HELP_CONTENT()                  'PATH_HELP_CONTENT' end
  def hkp_PATH_PROOF()                         'PATH_PROOF' end
  def hkp_PATH_TEMP()                          'PATH_TEMP' end
  def hkp_PATH_BIN()                           'PATH_BIN' end
  def hkp_PATH_LOGS_DEFAULT()                  'PATH_LOGS_DEFAULT' end
  def hkp_PATH_LOGS_USER()                     'PATH_LOGS_USER' end
  
  def hkp_PROXY_ADDRESS()                      'PROXY_ADDRESS' end
  def hkp_PROXY_PORT()                         'PROXY_PORT' end
  def hkp_PROXY_USERNAME()                     'PROXY_USERNAME' end
  def hkp_PROXY_PASSWORD()                     'PROXY_PASSWORD' end
  def hkp_SOCKS_ADDRESS()                      'SOCKS_ADDRESS' end
  def hkp_SOCKS_PORT()                         'SOCKS_PORT' end
  def hkp_SOCKS_USERNAME()                     'SOCKS_USERNAME' end
  def hkp_SOCKS_PASSWORD()                     'SOCKS_PASSWORD' end
  
  
  # hkp_Func*() related definitions 
  
  def hkp_FUNC_NAME()                          'FUNC_NAME' end
  def hkp_FUNC_DEFINED()                       'FUNC_DEFINED' end
  def hkp_FUNC_P1()                            'FUNC_PARAM1' end
  def hkp_FUNC_P2()                            'FUNC_PARAM2' end
  def hkp_FUNC_P3()                            'FUNC_PARAM3' end
  def hkp_FUNC_P4()                            'FUNC_PARAM4' end
  def hkp_FUNC_P5()                            'FUNC_PARAM5' end
  def hkp_FUNC_P6()                            'FUNC_PARAM6' end
  def hkp_FUNC_P7()                            'FUNC_PARAM7' end
  def hkp_FUNC_P8()                            'FUNC_PARAM8' end
  def hkp_FUNC_P9()                            'FUNC_PARAM9' end
  
  def hkp_f_GetCurrDateTimeFmt()               'GetCurrDateTimeFmt' end
  def hkp_f_GetUniqueName()                    'GetUniqueName' end
  def hkp_f_SaveToTempFile()                   'SaveToTempFile' end
  def hkp_f_SaveToFile()                       'SaveToFile' end
  def hkp_f_LoadFromFile()                     'LoadFromFile' end
  def hkp_f_ShellExecute()                     'ShellExecute' end
  def hkp_f_DDEExecute()                       'DDEExecute' end
  def hkp_f_ExecuteAndWait()                   'ExecuteAndWait' end
  def hkp_f_httpPostMPFD()                     'httpPostMPFD' end
  def hkp_f_OpenBrowser()                      'OpenBrowser' end
  def hkp_f_GetTempFileName()                  'GetTempFileName' end
  def hkp_f_GetTempFileNameExt()               'GetTempFileNameExt' end
  def hkp_f_regexSplitExt()                    'regexSplitExt' end
  def hkp_f_regexFound()                       'regexFound' end
  def hkp_f_regexGather()                      'regexGather' end
  def hkp_f_regexReplace()                     'regexReplace' end
  def hkp_f_statbarPushMsg()                   'statbarPushMsg' end
  def hkp_f_statbarPopMsg()                    'statbarPopMsg' end
  def hkp_f_msgwinClearAll()                   'msgwinClearAll' end
  def hkp_f_msgwinAdd()                        'msgwinAdd' end
  def hkp_f_cmndlgOpen()                       'cmndlgOpen' end
  def hkp_f_cmndlgSave()                       'cmndlgSave' end
  def hkp_f_fileGetSize()                      'fileGetSize' end
  def hkp_f_jpgGetImageInfo()                  'jpgGetImageInfo' end
  def hkp_f_gifGetImageInfo()                  'gifGetImageInfo' end
  def hkp_f_pngGetImageInfo()                  'pngGetImageInfo' end
  def hkp_f_CaseTag()                          'CaseTag' end
  def hkp_f_CaseAttr()                         'CaseAttr' end
  def hkp_f_CaseValue()                        'CaseValue' end
  def hkp_f_CaseEntity()                       'CaseEntity' end
  def hkp_f_CaseEvent()                        'CaseEvent' end
  def hkp_f_CaseProperty()                     'CaseProperty' end
  def hkp_f_FormatQuote()                      'FormatQuote' end
  def hkp_f_FormatColor()                      'FormatColor' end
  def hkp_f_HKPEnableFastAdd()                 'HKPEnableFastAdd' end
  def hkp_f_InvokeMenuCommandByCaption()       'InvokeMenuCommandByCaption' end
  def hkp_f_GetColor()                         'GetColor' end
  def hkp_f_Unformat()                         'Unformat' end
  def hkp_f_InvokeCommand()                    'InvokeCommand' end
  def hkp_f_UI_GetFileName()                   'UI_GetFileName' end
  def hkp_f_PluginDataWrite()                  'PluginDataWrite' end
  def hkp_f_PluginDataRead()                   'PluginDataRead' end
  def hkp_f_GetStyleCSS()                      'GetStyleCSS' end
  def hkp_f_OpenFileEx()                       'OpenFileEx' end
  def hkp_f_NewFile()                          'NewFile' end
  def hkp_f_FormatETET()                       'FormatETET' end
  def hkp_f_GetCursorXY()                      'GetCursorXY' end
  def hkp_f_SetCursorXY()                      'SetCursorXY' end
  def hkp_f_GetMarks()                         'GetMarks' end
  def hkp_f_SetMarks()                         'SetMarks' end
  def hkp_f_GetOpenFilesList()                 'GetOpenFilesList' end
  def hkp_f_GetSetFileContent()                'GetSetFileContent' end
  def hkp_f_PluginCacheClear()                 'PluginCacheClear' end
  def hkp_f_TextToFile()                       'TextToFile' end
  def hkp_f_Progress()                         'Progress' end
  def hkp_f_FormatEqual()                      'FormatEqual' end
  def hkp_f_FormatSpaceOpt()                   'FormatSpaceOpt' end
  def hkp_f_FormatNewLineOpt()                 'FormatNewLineOpt' end
  def hkp_f_ShowHelp()                         'ShowHelp' end
  def hkp_f_GetCalc()                          'GetCalc' end
  def hkp_f_urlGetRelPath()                    'urlGetRelPath' end
  def hkp_f_ProcessToken()                     'ProcessToken' end
  def hkp_f_URL2File()                         'URL2File' end
  def hkp_f_ShellLink()                        'ShellLink' end
  def hkp_f_CopyColor()                        'CopyColor' end
  def hkp_f_Clipboard()                        'Clipboard' end
  def hkp_f_IconReplace()                      'IconReplace' end
  def hkp_f_Speech()                           'Speech' end
  def hkp_f_RichHint()                         'RichHint' end
  def hkp_f_TimeTracker()                      'TimeTracker' end
  def hkp_f_Desktop()                          'Desktop' end
  def hkp_f_Buffer()                           'Buffer' end
  def hkp_f_String()                           'String' end
  def hkp_f_File()                             'File' end
  def hkp_f_InputWizard()                      'InputWizard' end
  def hkp_f_Preferences()                      'Preferences' end
  def hkp_f_Recall()                           'Recall' end
  
  
  # Parameters used to report progress 
  
  def hkp_STATUS_LINES_IN_CURRENT()            'STATUS_LINES_IN_CURRENT' end
  def hkp_STATUS_LINES_IN_TOTAL()              'STATUS_LINES_IN_TOTAL' end
  def hkp_STATUS_LINES_OUT_CURRENT()           'STATUS_LINES_OUT_CURRENT' end
  def hkp_STATUS_LINES_OUT_TOTAL()             'STATUS_LINES_OUT_TOTAL' end
  def hkp_STATUS_PERCENT_COMPLETED()           'STATUS_PERCENT_COMPLETED' end
  def hkp_STATUS_ERRORS_COUNT()                'STATUS_ERRORS_COUNT' end
  def hkp_STATUS_WARNINGS_COUNT()              'STATUS_WARNINGS_COUNT' end
  def hkp_STATUS_PROGRESS_MESSAGE()            'STATUS_PROGRESS_MESSAGE' end
  def hkp_STATUS_DIVIDER_LINES()               'STATUS_DIVIDER_LINES' end
  
  
  # Plugin specific definitions 
  
  def hkp_c_PLUGIN_NAME_HTMLTIDY()             'HTML Tidy' end
  
  def hkp_MODE_TIDY()                          'MODE_TIDY' end
  def hkp_CONFIG_TIDY()                        'CONFIG_TIDY' end
  def hkp_MESSAGES_TIDY()                      'MESSAGES_TIDY' end
  
  
  # Obsolete definition names 
  
  def hkp_c_strTRUE()                          '1' end
  def hkp_c_strFALSE()                         '0' end
  
  def hkp_c_DefaultQuoteStr()                  '"' end
  def hkp_c_DefaultQuoteChar()                 '"' end


  # --- methods ---

  def initialize
    @l_v = WIN32OLE.new( hkp_c_OLEObj_HKPCore )
  end

  def hkp_Quit
    @l_v = nil
  end

  def hkp_DataAdd( sParam, sValue )
    return @l_v.hkp_DataAdd( sParam, sValue )
  end

  def hkp_DataAddInt( sParam, nValue )
    return @l_v.hkp_DataAddInt( sParam, nValue )
  end

  def hkp_DataSetGlobalSuffix( sSuffix )
    return @l_v.hkp_DataSetGlobalSuffix( sSuffix )
  end

  def hkp_DataSetGlobalPrefix( sPrefix )
    return @l_v.hkp_DataSetGlobalPrefix( sPrefix )
  end

  def hkp_DataFound( sParam )
    return @l_v.hkp_DataFound( sParam )
  end

  def hkp_DataGet( sParam, psValue )
    nStatus = @l_v.hkp_DataFound( sParam )
    if( nStatus )
      psValue.replace( @l_v.hkp_DataGetStr( sParam ) )
    end
    return nStatus
  end

  def hkp_DataGetInt( sParam, nDefaultValue )
    return @l_v.hkp_DataGetInt( sParam, nDefaultValue )
  end

  def hkp_DataGetStr( sParam, sDefaultValue )
    return @l_v.hkp_DataGetStr( sParam, sDefaultValue )
  end

  def hkp_FuncOpen( sName )
    return @l_v.hkp_FuncOpen( sName )
  end

  def hkp_FuncRun()
    return @l_v.hkp_FuncRun()
  end

  def hkp_FuncClose()
    return @l_v.hkp_FuncClose()
  end

end


def hkp_CreateObjectHKPCore()
  return WIN32OLE.new( 'htmlkit.HTMLKitPluginsCore' )
end

def hkp_Quit( v )
end

def hkp_mode_register()
  return ( ('-hkpreg' == ARGV[0]) || ('-hkpreg' == ENV[ 'HKPCORE_PLUGIN_INVOKE_MODE_ENV' ]) )
end

def hkp_mode_run()
  return ( ('-hkprun' == ARGV[0]) || ('-hkprun' == ENV[ 'HKPCORE_PLUGIN_INVOKE_MODE_ENV' ]) )
end



#
#   --- History ---
#   31-Jul-2002: Version 1.0.50 / Build 292 Alpha 4 (20020731)
#     + hkp_MODE_BUFFER_FILETYPES_INCLUDED,
#       hkp_MODE_BUFFER_FILETYPES_EXCLUDED
# 
#   30-Jul-2002: Version 1.0.49 / Build 292 Alpha 4 (20020730)
#     + hkp_MODE_INFO_KEYWORDS,
#       hkp_c_Section_BatchActions
# 
#   30-Jul-2002: Version 1.0.48 / Build 292 Alpha 4 (20020729)
#     + hkp_BUFFER_PARAM_HINT1,
#       hkp_BUFFER_PARAM_HINT2,
#       hkp_BUFFER_PARAM_HINT3,
#       hkp_BUFFER_PARAM_HINT4
# 
#   28-Jul-2002: Version 1.0.47 / Build 292 Alpha 4 (20020728)
#     + hkp_MODE_BUFFER_FILTER_REGEX_EXPR,
#       hkp_MODE_BUFFER_FILTER_REGEX_OPT
# 
#   27-Jul-2002: Version 1.0.46 / Build 292 Alpha 4 (20020726)
#     + hkp_MODE_BUFFER_CACHE_PLUGIN_DISABLE,
#       hkp_MODE_BUFFER_INFO_PLUGIN_FULL,
#       hkp_MODE_BUFFER_INFO_USER_HIDE
# 
#   24-Jul-2002: Version 1.0.45 / Build 292 Alpha 4 (20020724)
#     + hkp_BuffLen,
#       hkp_BuffCopy
# 
#   20-Jul-2002: Version 1.0.44 / Build 292 Alpha 4 (20020720)
#     + hkp_CAPABILITY_AUTORESIZINGMENU
# 
#   06-Jul-2002: Version 1.0.43 / Build 292 Alpha 4 (20020706)
#     + hkp_MODE_UNINSTALL,
#       hkp_UNINSTALL_FILE_ABS,
#       hkp_UNINSTALL_FILE_REL,
#       hkp_UNINSTALL_FILE_REL_PLUGINS,
#       hkp_UNINSTALL_FILE_REL_PLUGINS_CONFIG,
#       hkp_UNINSTALL_FILE_REL_PLUGINS_BIN,
#       hkp_UNINSTALL_FILE_REL_PLUGINS_LIB,
#       hkp_UNINSTALL_DIR_ABS,
#       hkp_UNINSTALL_DIR_REL_PLUGINS_CONFIG,
#       hkp_UNINSTALL_REG_ABS,
#       hkp_UNINSTALL_REG_REL,
#       hkp_UNINSTALL_EVENT_ONINVOKE,
#       hkp_c_Uninstall_Event_OnInvoke,
#       hkp_CAPABILITY_UNINSTALL,
#       hkp_MODE_BUFFER_VISIBLE_MAINMENU,
#       hkp_MODE_BUFFER_VISIBLE_WORKSPACE,
#       hkp_MODE_BUFFER_ACCESS_READ,
#       hkp_MODE_BUFFER_ACCESS_WRITE,
#       hkp_MODE_BUFFER_ACCESS_CREATE,
#       hkp_LICENSE_TYPE,
#       hkp_LICENSE_DESCRIPTION,
#       hkp_LICENSE_URL,
#       hkp_REGISTRATION_TYPE,
#       hkp_REGISTRATION_DESCRIPTION,
#       hkp_REGISTRATION_FEE,
#       hkp_REGISTRATION_URL,
#       hkp_URL_HELP
# 
# 
#   20-May-2002: Version 1.0.42 / Build 292 Alpha 4 (20020520)
#     + hkp_f_Recall,
#       hkp_UPID,
#       hkp_RECALL_EVENT_ONINVOKE,
#       hkp_RECALL_IN_DATA1,
#       hkp_RECALL_IN_DATA2,
#       hkp_c_Recall_Event_OnInvoke,
#       hkp_CAPABILITY_RECALL
# 
#   11-May-2002: Version 1.0.41 / Build 292 Alpha 4 (20020511)
#     + hkp_f_InputWizard,
#       hkp_f_Preferences
# 
#   24-Apr-2002: Version 1.0.40 / Build 292 Alpha 3 (20020424)
#     + hkp_DRAGDROP_ACCEPT_FILEMASKS,
#       hkp_DRAGDROP_ACCEPT_MODES,
#       hkp_MODE_DRAGDROP_IN_SOURCE_FILE_LOCAL,
#       hkp_DRAGDROP_EVENT_ONDROP,
#       hkp_DRAGDROP_OUTPUT,
#       hkp_DRAGDROP_IN_MODE,
#       hkp_DRAGDROP_IN_SOURCE_FILE_PATH_ABS,
#       hkp_DRAGDROP_IN_SOURCE_FILE_PATH_REL,
#       hkp_DRAGDROP_IN_SOURCE_FILE_NAME_EXT,
#       hkp_DRAGDROP_IN_SOURCE_FILE_NAME_FULL,
#       hkp_DRAGDROP_IN_SOURCE_PATH_ABS,
#       hkp_DRAGDROP_IN_SOURCE_PATH_REL,
#       hkp_DRAGDROP_IN_SOURCE_FILE_LOCAL,
#       hkp_c_DragDrop_Event_OnDrop,
#       hkp_c_DragDrop_Mode_Workspace,
#       hkp_CAPABILITY_DRAGDROP,
#       hkp_f_File
# 
#   09-Apr-2002: Version 1.0.39 / Build 292 Alpha 3 (20020409)
#     + hkp_f_String
# 
#   04-Apr-2002: Version 1.0.38 / Build 292 Alpha 3 (20020404)
#     + hkp_BUFFER_PARAM_LABEL1,
#       hkp_BUFFER_PARAM_LABEL2,
#       hkp_BUFFER_PARAM_LABEL3,
#       hkp_BUFFER_PARAM_LABEL4,
#       hkp_BUFFER_PARAM_VALUE1,
#       hkp_BUFFER_PARAM_VALUE2,
#       hkp_BUFFER_PARAM_VALUE3,
#       hkp_BUFFER_PARAM_VALUE4,
#       hkp_MODE_SESSION_ENABLE,
#       hkp_BUFFER_REPORT_OUTPUT,
#       hkp_SESSION_VAR_COUNT,
#       hkp_SESSION_VAR1,
#       hkp_SESSION_VAR2,
#       hkp_SESSION_VAR3,
#       hkp_SESSION_VAR4,
#       hkp_SESSION_FRIENDS
# 
#   28-Mar-2002: Version 1.0.37 / Build 292 Alpha 3 (20020328)
#     + hkp_BUFFER_CAPTION,
#       hkp_BUFFER_HINT,
#       hkp_BUFFER_EVENT_ONINVOKE,
#       hkp_BUFFER_EVENT_ONSTART,
#       hkp_BUFFER_EVENT_ONEND,
#       hkp_BUFFER_EVENT_ONENTERFOLDER,
#       hkp_BUFFER_EVENT_ONEXITFOLDER,
#       hkp_c_Buffer_Event_OnInvoke,
#       hkp_c_Buffer_Event_OnStart,
#       hkp_c_Buffer_Event_OnEnd,
#       hkp_c_Buffer_Event_OnEnterFolder,
#       hkp_c_Buffer_Event_OnExitFolder,
#       hkp_CAPABILITY_BUFFER,
#       hkp_MODE_BUFFER_IN_FILE,
#       hkp_MODE_BUFFER_IN_CONTENT,
#       hkp_BUFFER_IN_FILE,
#       hkp_BUFFER_IN_CONTENT,
#       hkp_BUFFER_IN_PATH,
#       hkp_BUFFER_IN_DEPTH,
#       hkp_f_Buffer,
#       hkp_BUFFER_IN_PARAM1,
#       hkp_BUFFER_IN_PARAM2,
#       hkp_BUFFER_IN_PARAM3,
#       hkp_BUFFER_IN_PARAM4
# 
#   25-Mar-2002: Version 1.0.36 / Build 292 Alpha 3 (20020326)
#     + hkp_f_Desktop,
#       hkp_TEMPLATEWIZARD_CAPTION,
#       hkp_TEMPLATEWIZARD_HINT,
#       hkp_TEMPLATEWIZARD_EVENT_ONINVOKE,
#       hkp_c_TemplateWizard_Event_OnInvoke,
#       hkp_CAPABILITY_TEMPLATEWIZARD
# 
#   14-Mar-2002: Version 1.0.35 / Build 292 Alpha 3 (20020314)
#     + hkp_f_TimeTracker,
#       hkp_PATH_LOGS_DEFAULT,
#       hkp_PATH_LOGS_USER
# 
#   10-Mar-2002: Version 1.0.34 / Build 292 Alpha 3 (20020310)
#     + hkp_f_RichHint
# 
#   03-Mar-2002: Version 1.0.33 / Build 292 Alpha 3 (20020304)
#     + hkp_DROPDOWN_ITEM_PHRASE,
#       hkp_f_Speech,
#       hkp_CAPABILITY_TEXTTOSPEECH,
#       hkp_CAPABILITY_SPEECHRECOGNITION
# 
#   02-Mar-2002: Version 1.0.32 / Build 292 Alpha 3 (20020302)
#     + hkp_COMMANDPROMPT_EVENT_ONINVOKE,
#       hkp_c_CommandPrompt_Event_OnInvoke,
#       hkp_COMMANDPROMPT_HINT,
#       hkp_COMMANDPROMPT_HELP,
#       hkp_COMMANDPROMPT_COMMANDS,
#       hkp_COMMANDPROMPT_OUTPUT,
#       hkp_COMMANDPROMPT_HANDLED,
#       hkp_COMMANDPROMPT_IN_CMDLINE_FULL,
#       hkp_COMMANDPROMPT_IN_CMDLINE_COMMAND,
#       hkp_COMMANDPROMPT_IN_CMDLINE_PARAMS,
#       hkp_COMMANDPROMPT_IN_CMDLINE_PARAM,
#       hkp_CAPABILITY_COMMANDPROMPT
# 
#   03-Feb-2002: Version 1.0.31 / Build 292 Alpha 2 (20020103)
#     + hkp_ICON_SHARED_INDEX,
#       hkp_CAPABILITY_CONTEXTMENU_EDITOR,
#       hkp_MODE_CONTEXTMENU_EDITOR_PRELOAD,
#       hkp_CONTEXTMENU_EDITOR_HINT_INIT,
#       hkp_CONTEXTMENU_EDITOR_HINT_QUIT,
#       hkp_f_IconReplace,
#       hkp_c_MODE_ICON_DRAW
# 
#   28-Jan-2002: Version 1.0.30 / Build 292 Alpha 2 (20020128)
#     + hkp_f_CopyColor,
#       hkp_f_Clipboard
# 
#   27-Jan-2002: Version 1.0.29 / Build 292 Alpha 2 (20020127)
#     + hkp_ICON_INDEX,
#       hkp_f_ShellLink,
#       hkp_CONTEXTMENU_EDITOR_EVENT_ONINIT,
#       hkp_CONTEXTMENU_EDITOR_EVENT_ONOPEN,
#       hkp_CONTEXTMENU_EDITOR_EVENT_ONCLOSE,
#       hkp_CONTEXTMENU_EDITOR_EVENT_ONCLICK,
#       hkp_c_ContextMenu_Editor_Event_OnInit,
#       hkp_c_ContextMenu_Editor_Event_OnOpen,
#       hkp_c_ContextMenu_Editor_Event_OnClose,
#       hkp_c_ContextMenu_Editor_Event_OnClick,
#       hkp_CONTEXTMENU_EDITOR_VISIBLE,
#       hkp_CONTEXTMENU_EDITOR_ENABLED,
#       hkp_CONTEXTMENU_EDITOR_SECTION,
#       hkp_CONTEXTMENU_EDITOR_HINT,
#       hkp_CONTEXTMENU_EDITOR_ICONINDEX,
#       hkp_CONTEXTMENU_EDITOR_ITEM,
#       hkp_CONTEXTMENU_EDITOR_ITEM_HINT,
#       hkp_CONTEXTMENU_EDITOR_ITEM_DATA,
#       hkp_CONTEXTMENU_EDITOR_ITEM_ICONINDEX,
#       hkp_CONTEXTMENU_EDITOR_ITEM_ENABLED
# 
#   09-Jan-2002: Version 1.0.28 / Build 292 Alpha 2 (20020109)
#     + hkp_MODE_PREVIEW_PASS_TO_NEXT,
#       hkp_MODE_PREVIEW_IN_URL,
#       hkp_MODE_PREVIEW_IN_CONTENT,
#       hkp_PREVIEW_IN_URL,
#       hkp_PREVIEW_IN_CONTENT
#     * renamed hkp_PREVIEW_SOURCE_URL to hkp_PREVIEW_OUTPUT_URL
#     * renamed hkp_PREVIEW_SOURCE_CONTENT to hkp_PREVIEW_OUTPUT_CONTENT
# 
#   05-Jan-2002: Version 1.0.27 / Build 292 Alpha 2 (20020105)
#     + hkp_BUTTON_VISIBLE,
#       hkp_PREVIEW_EVENT_ONPREVIEW,
#       hkp_c_Preview_Event_OnPreview,
#       hkp_PREVIEW_SOURCE_URL,
#       hkp_PREVIEW_SOURCE_CONTENT
# 
#   03-Jan-2002: Version 1.0.26 / Build 292 Alpha 2 (20020103)
#     * "added hkp_Found() and hkp_DataGetStr() to Java and C# classes"
#     * "added hkp_Quit() to the Perl module"
# 
#   20-Dec-2001: Version 1.0.25 / Build 292 Alpha 1 (20011220)
#     * "created HKPCore class for Python"
#     * "created HKPCore class for PHP"
#     * "made $hkp_* parameters members of the Ruby class"
# 
#   18-Dec-2001: Version 1.0.24 / Build 292 Alpha 1 (20011218)
#     * "support for writing plugins in Ruby"
# 
#   15-Dec-2001: Version 1.0.23 / Build 292 Alpha 1 (20011215)
#     + hkp_HKPCORE_PLUGIN_INVOKE_MODE_ENV
#     * "support for writing plugins in Python"
# 
#   14-Dec-2001: Version 1.0.22 / Build 292 Alpha 1 (20011214)
#     * "support for writing plugins in PHP"
# 
#   12-Dec-2001: Version 1.0.21 / Build 292 Alpha 1 (20011212)
#     + hkp_PREF_FORMAT_ALT
# 
#   29-Nov-2001: Version 1.0.20 / Build 292 Alpha 1 (20011129)
#     + hkp_SOCKS_ADDRESS, 
#       hkp_SOCKS_PORT,
#       hkp_SOCKS_USERNAME, 
#       hkp_SOCKS_PASSWORD
# 
#   01-Nov-2000: Version 1.0.19 / Build 290 Alpha 11 (20001101)
#     * "renamed hkp_f_jpgGetSize to hkp_f_jpgGetImageInfo"
#     * "renamed hkp_f_gifGetSize to hkp_f_gifGetImageInfo"
#     + hkp_f_pngGetImageInfo,
#       hkp_f_URL2File,
#       hkp_MODE_IN_LINE_AT_CURSOR,
#       hkp_INPUT_LINE_AT_CURSOR,
#       hkp_c_MODE_OUTPUT_CURRENTLINE,
#       hkp_MODE_EGG
# 
#   15-Jul-2000: Version 1.0.18 / Build 290 Alpha 11 (20000715)
#     * "renamed hkp_c_ColorCode to hkp_c_ColorHex6"
#     * "renamed hkp_f_jpgGetWidthHeight to hkp_f_jpgGetSize"
#     - hkp_ProcAddr_TextToFile
#     + hkp_ProcAddr_Reserved,
#       hkp_c_ColorRGB,
#       hkp_c_ColorRGBPercent,
#       hkp_c_ColorHex3,
#       hkp_c_FormatTag_ColorExt,
#       hkp_c_Section_Online,
#       hkp_c_EqualDefault,
#       hkp_c_EqualSpaceNone,
#       hkp_c_EqualSpaceLeft,
#       hkp_c_EqualSpaceRight,
#       hkp_c_EqualSpaceBoth,
#       hkp_c_SpaceOptDefault,
#       hkp_c_SpaceOptInclude,
#       hkp_c_SpaceOptExclude,
#       hkp_c_NewLineOptDefault,
#       hkp_c_NewLineOptInclude,
#       hkp_c_NewLineOptExclude,
#       hkp_c_FormatTag_Equal,
#       hkp_c_FormatTag_SpaceOpt,
#       hkp_c_FormatTag_NewLineOpt,
#       hkp_c_str_DefaultEqual,
#       hkp_c_chr_DefaultEqual,
#       hkp_c_str_DefaultSpaceOpt,
#       hkp_c_chr_DefaultSpaceOpt,
#       hkp_c_str_DefaultNewLineOpt,
#       hkp_c_chr_DefaultNewLineOpt,
#       hkp_c_str_TRUE,
#       hkp_c_str_FALSE,
#       hkp_c_str_DefaultQuote,
#       hkp_c_chr_DefaultQuote,
#       hkp_DROPDOWN_ITEM_HINT,
#       hkp_DROPDOWN_ITEM_ICON,
#       hkp_f_GetCursorXY,
#       hkp_f_SetCursorXY,
#       hkp_f_GetMarks,
#       hkp_f_SetMarks,
#       hkp_f_GetOpenFilesList,
#       hkp_f_GetSetFileContent,
#       hkp_f_PluginCacheClear,
#       hkp_f_TextToFile,
#       hkp_f_Progress,
#       hkp_f_FormatEqual,
#       hkp_f_FormatSpaceOpt,
#       hkp_f_FormatNewLineOpt,
#       hkp_f_ShowHelp,
#       hkp_f_jpgGetSize,
#       hkp_f_gifGetSize,
#       hkp_f_GetCalc,
#       hkp_f_urlGetRelPath,
#       hkp_f_ProcessToken,
#       hkp_PLUGIN_FILE,
#       hkp_PROGRAM_HANDLE,
#       hkp_VER_TIMESTAMP,
#       hkp_VER_TYPE,
#       hkp_VER_RELEASE_ID,
#       hkp_MODE_APPEARANCE_ICONS,
#       hkp_MODE_EDITOR_REQUIRED,
#       hkp_EDITOR_AVAILABLE,
#       hkp_APPEARANCE_NAME,
#       hkp_PREF_DATETIME_FORMAT,
#       hkp_MODE_END_GROUP,
#       hkp_LABEL_VISIBLE,
#       hkp_LABEL_WIDTH,
#       hkp_LABEL_WIDTH_CHAR,
#       hkp_LABEL_HINT,
#       hkp_LABEL_TEXT,
#       hkp_LABEL_ALIGNMENT,
#       hkp_LABEL_STYLE,
#       hkp_LABEL_DIRTY,
#       hkp_LABEL_HANDLE,
#       hkp_LABEL_EVENT_ONCLICK,
#       hkp_LABEL_EVENT_ONDBLCLICK,
#       hkp_LABEL_EVENT_ONMOUSEDOWN,
#       hkp_COMBOBOX_VISIBLE,
#       hkp_COMBOBOX_WIDTH,
#       hkp_COMBOBOX_WIDTH_CHAR,
#       hkp_COMBOBOX_DROPDOWN_COUNT,
#       hkp_COMBOBOX_HINT,
#       hkp_COMBOBOX_STYLE,
#       hkp_COMBOBOX_SORTED,
#       hkp_COMBOBOX_TEXT,
#       hkp_COMBOBOX_CHAR_MAX,
#       hkp_COMBOBOX_DIRTY,
#       hkp_COMBOBOX_HANDLE,
#       hkp_COMBOBOX_ITEMS_GET,
#       hkp_COMBOBOX_ITEMS_COUNT,
#       hkp_COMBOBOX_ITEMS_CURR_INDEX,
#       hkp_COMBOBOX_ITEMS_CURR_TEXT,
#       hkp_COMBOBOX_ITEMS_CURR_DATA,
#       hkp_COMBOBOX_ITEMS_DELETE_ALL,
#       hkp_COMBOBOX_ITEMS_INSERT_TOP,
#       hkp_COMBOBOX_ITEMS_IGNORE_DUPLICATES,
#       hkp_COMBOBOX_ITEM,
#       hkp_COMBOBOX_ITEM_DATA,
#       hkp_COMBOBOX_EVENT_ONCHANGE,
#       hkp_COMBOBOX_EVENT_ONDROPDOWN,
#       hkp_COMBOBOX_EVENT_ONCLICK,
#       hkp_COMBOBOX_EVENT_ONKEYPRESS,
#       hkp_COMBOBOX_EVENT_ONMOUSEDOWN,
#       hkp_COMBOBOX_KEYPRESS_FILTER,
#       hkp_EDITFIELD_VISIBLE,
#       hkp_EDITFIELD_WIDTH,
#       hkp_EDITFIELD_WIDTH_CHAR,
#       hkp_EDITFIELD_HINT,
#       hkp_EDITFIELD_TEXT,
#       hkp_EDITFIELD_CHAR_MAX,
#       hkp_EDITFIELD_DIRTY,
#       hkp_EDITFIELD_HANDLE,
#       hkp_EDITFIELD_EVENT_ONCHANGE,
#       hkp_EDITFIELD_EVENT_ONKEYPRESS,
#       hkp_EDITFIELD_EVENT_ONMOUSEDOWN,
#       hkp_EDITFIELD_KEYPRESS_FILTER,
#       hkp_c_Button_Event_OnClick,
#       hkp_c_Menu_Event_OnClick,
#       hkp_c_Label_Event_OnClick,
#       hkp_c_Label_Event_OnDblClick,
#       hkp_c_Label_Event_OnMouseDown,
#       hkp_c_Label_Alignment_Left,
#       hkp_c_Label_Alignment_Center,
#       hkp_c_Label_Alignment_Right,
#       hkp_c_Label_GetData,
#       hkp_c_Label_SetData,
#       hkp_c_ComboBox_Event_OnChange,
#       hkp_c_ComboBox_Event_OnDropDown,
#       hkp_c_ComboBox_Event_OnClick,
#       hkp_c_ComboBox_Event_OnKeyPress,
#       hkp_c_ComboBox_Event_OnMouseDown,
#       hkp_c_ComboBox_Style_DropDown,
#       hkp_c_ComboBox_Style_DropDownList,
#       hkp_c_ComboBox_Style_Simple,
#       hkp_c_ComboBox_GetData,
#       hkp_c_ComboBox_SetData,
#       hkp_c_EditField_Event_OnChange,
#       hkp_c_EditField_Event_OnKeyPress,
#       hkp_c_EditField_Event_OnMouseDown,
#       hkp_c_EditField_GetData,
#       hkp_c_EditField_SetData,
#       hkp_MODE_FOCUS_EDITOR,
#       hkp_ARGV2,
#       hkp_ARGV3,
#       hkp_ARGV4,
#       hkp_ARGV5,
#       hkp_EVENT,
#       HKP_UINT16,
#       HKP_INT32,
#       HKP_INT64
# 
#   10-Jun-2000: Version 1.0.17 / Build 290 Alpha 11 (20000701)
#     + hkp_c_OLEObj_HKPCore
# 
#   10-Jun-2000: Version 1.0.16 / Build 290 Alpha 11 (20000610)
#     + hkp_PATH_SNIPPETS_DEFAULT,
#       hkp_PATH_TEMPLATES_DEFAULT,
#       hkp_PATH_SNIPPETS_USER,
#       hkp_PATH_TEMPLATES_USER,
#       hkp_PATH_PLUGINS_CONFIG,
#       hkp_PATH_BACKUP,
#       hkp_PATH_CACHE,
#       hkp_PATH_DATA,
#       hkp_PATH_DATA_DEFAULT,
#       hkp_PATH_HELP,
#       hkp_PATH_HELP_KEYWORDS,
#       hkp_PATH_HELP_CONTENT,
#       hkp_PATH_PROOF,
#       hkp_PATH_TEMP,
#       hkp_PATH_BIN,
#       hkp_c_FormatTag_ETET,
#       hkp_c_ETETDefault,
#       hkp_c_ETETInclSpc,
#       hkp_c_ETETExclSpc,
#       hkp_c_str_ETETInclSpc,
#       hkp_c_str_ETETExclSpc,
#       hkp_f_FormatETET,
#       hkp_PREF_FORMAT_ETET,
#       hkp_PREF_FORMAT_ETET_SKIP_OPTIONAL
# 
#   29-Apr-2000: Version 1.0.15 / Build 290 Beta 10
#     + hkp_MODE_PLUGIN_CACHE,
#       hkp_c_MODE_PLUGIN_CACHE_NONE,
#       hkp_c_MODE_PLUGIN_CACHE_ALL,
#       hkp_c_MODE_ICON_BUILTIN,
#       hkp_c_Section_Style,
#       hkp_EDITOR_WINDOW_HANDLE,
#       hkp_f_UI_GetFileName,
#       hkp_f_PluginDataWrite,
#       hkp_f_PluginDataRead,
#       hkp_f_GetStyleCSS,
#       hkp_f_OpenFileEx,
#       hkp_f_NewFile,
#       hkp_COMMAND_BUILTIN
#     * "Changed default value for hkp_MODE_SHOW_STATUS to hkp_c_FALSE"
#     * "Set default value for hkp_MODE_CONSOLE to hkp_c_strTRUE"
#     * "Set default value for hkp_MODE_PLUGIN_CACHE to hkp_c_MODE_PLUGIN_CACHE_ALL"
# 
#   30-Mar-2000: Version 1.0.14 / Build 290 Beta 9
#     + hkp_c_MODE_OUTPUT_EDITOR_NEW,
#       hkp_f_InvokeCommand
# 
#   13-Feb-2000: Version 1.0.13 / Build 290 Beta 8
#     + hkp_MODE_BEGIN_GROUP
# 
#   03-Feb-2000: Version 1.0.12 / Build 290 Beta 7
#     + hkp_FILE_DISP_NAME, 
#       hkp_FILE_DISP_NAME_SHORT
# 
#   05-Dec-1999: Version 1.0.11 / Build 286
#     + hkp_f_HKPEnableFastAdd, 
#       hkp_f_InvokeMenuCommandByCaption,
#       hkp_f_FormatColor, 
#       hkp_PREF_FORMAT_COLOR,
#       hkp_c_ColorDefault,
#       hkp_c_ColorCode,
#       hkp_c_ColorName,
#       hkp_c_FormatTag_Color, 
#       hkp_f_GetColor, 
#       hkp_f_Unformat
# 
#   30-Oct-1999: Version 1.0.10 / Build 282
#     + hkp_c_FormatTag_Token, 
#       hkp_PREF_FORMAT_QUOTE_SKIP_OPTIONAL,
#       hkp_c_DefaultQuoteChar, 
#       hkp_c_DefaultQuoteStr,
#       hkp_c_FormatTag_QuoteReq, 
#       hkp_c_FormatTag_QuoteOpt,
#       hkp_f_FormatQuote, 
#       hkp_PREF_FORMAT_QUOTE,
#       hkp_c_QuoteDefault, 
#       hkp_c_QuoteSingle,
#       hkp_c_QuoteDouble
# 
#   23-Oct-1999: Version 1.0.9 / Build 280
#     * "Changed hkp_c_CaseNoPref to hkp_c_CaseDefault"
#     * "Changed hkp_PREF_CASE_TAGS to hkp_PREF_CASE_TAG"
#     + hkp_f_CaseEvent, 
#       hkp_f_CaseProperty,
#       hkp_PREF_CASE_VALUE, 
#       hkp_PREF_CASE_ENTITY,
#       hkp_PREF_CASE_EVENT, 
#       hkp_PREF_CASE_PROPERTY,
#       hkp_PREF_AUTHOR_NAME, 
#       hkp_PREF_AUTHOR_COMPANY,
#       hkp_PREF_AUTHOR_WEBSITE, 
#       hkp_PREF_AUTHOR_EMAIL,
#       hkp_PREF_AUTHOR_COMMENTS, 
#       hkp_MODE_PREPROCESS_FORMAT_TAGS,
#       hkp_c_FormatTag_NormalText, 
#       hkp_c_FormatTag_Tag,
#       hkp_c_FormatTag_Attr, 
#       hkp_c_FormatTag_Value,
#       hkp_c_FormatTag_Entity, 
#       hkp_c_FormatTag_Event,
#       hkp_c_FormatTag_Property
# 
#   11-Oct-1999: Version 1.0.8 / Build 278
#     + hkp_MODE_ADD_MENU_SHORTCUTS, 
#       hkp_MODE_ICON,
#       hkp_c_MODE_ICON_RES, 
#       hkp_c_MODE_ICON_DATA,
#       hkp_c_MODE_ICON_FILE,
#       hkp_f_CaseTag, 
#       hkp_f_CaseAttr,
#       hkp_f_CaseValue,
#       hkp_f_CaseEntity
# 
#   30-Aug-1999: Version 1.0.7 / Build 266
#     * "Changed hkp_STATUS_OUTLINESCOUNT to hkp_STATUS_LINES_OUT_CURRENT"
#     + hkp_STATUS_LINES_IN_CURRENT, 
#       hkp_STATUS_LINES_IN_TOTAL,
#       hkp_STATUS_LINES_OUT_TOTAL, 
#       hkp_STATUS_PERCENT_COMPLETED,
#       hkp_STATUS_ERRORS_COUNT,
#       hkp_STATUS_WARNINGS_COUNT,
#       hkp_STATUS_PROGRESS_MESSAGE, 
#       hkp_c_MODE_OUTPUT_EDITOR
# 
#   15-Jul-1999: Version 1.0.6 / Build 252
#     + hkp_OWNER_WINDOW_HANDLE,
#       hkp_MODE_DEBUG_PLUGIN,
#       hkp_PREF_SHORT_MENUS, 
#       hkp_PREF_MENU_HEIGHT,
#       hkp_PREF_CASE_TAGS, 
#       hkp_PREF_CASE_ATTR,
#       hkp_FILE_TYPE_FILTER_DOCS, 
#       hkp_FILE_TYPE_FILTER_IMAGES,
#       hkp_FILE_TYPE_FILTER_DEFAULT,
#       hkp_PATH_ROOT, 
#       hkp_PATH_PLUGINS,
#       hkp_PATH_LAST_OPEN, 
#       hkp_PATH_LAST_SAVE,
#       hkp_PROXY_ADDRESS, 
#       hkp_PROXY_PORT,
#       hkp_PROXY_USERNAME, 
#       hkp_PROXY_PASSWORD,
#       hkp_c_CaseUpper, 
#       hkp_c_CaseLower, 
#       hkp_c_CaseNoPref
# 
#   02-Jul-1999: Version 1.0.4 / Build 250
#     + HKP_m_Add_NameVerSectDescHint,
#       HKP_m_Add_NameVerSectDescHintIcon,
#       hkp_f_regexReplace,
#       hkp_MODE_IN_TAG_AT_CURSOR, 
#       hkp_c_MODE_OUTPUT_CURRENTWORD, 
#       hkp_c_MODE_OUTPUT_CURRENTTAG, 
#       hkp_INPUT_TAG_AT_CURSOR,
#       hkp_f_statbarPushMsg, 
#       hkp_f_statbarPopMsg, 
#       hkp_f_msgwinClearAll,
#       hkp_f_msgwinAdd
# 
#   26-Jun-1999: Version 1.0.3 / Build 250
#     + hkp_MODE_IN_FILE, 
#       hkp_INPUT_FILE, 
#       hkp_MODE_IN_FILE_EXT, 
#       hkp_MODE_IN_FILE_DELETE, 
#       hkp_f_httpPostMPFD, 
#       hkp_f_OpenBrowser, 
#       hkp_f_GetTempFileName,
#       hkp_f_GetTempFileNameExt, 
#       hkp_f_regexSplitExt, 
#       hkp_f_regexFound, 
#       hkp_f_regexGather
# 

